//-----------------------------------------------------------------------------
// customvis.m
//
// Creates a Custom Visualization from an Animated Layer
//
// To Use this script:
//
// 1) Put the customvis.maki file in your scripts folder
// 2) Put <script id="customvis" file="scripts/customvis.maki"/> in the same group
//       as your animated layer
// 3) Done!
//
// by iPlayTheSpoons
//
//-----------------------------------------------------------------------------

#include "lib/std.mi"

Function UpdateVis(int vFrame,int vFrameL,int vFrameR);

Global AnimatedLayer MainVis, LeftVU, RightVU;
Global Timer VisTimer;
Global Double Level, LevelL, LevelR, OneFrame, OneFrame2;
Global Int LastFrame, LastFrameL, LastFrameR;

System.onScriptLoaded() { 

	//Rtegek lekrdezse
	Group VisGroup = getScriptGroup();
	MainVis = VisGroup.getObject("layer.vis");
	LeftVU = VisGroup.getObject("layer.vu.left");
	RightVU = VisGroup.getObject("layer.vu.right");

	//Idzt belltsa		
	VisTimer = new Timer;
	VisTimer.setDelay(50);
	VisTimer.start();
	//Sebessgek belltsa
	MainVis.setSpeed(50);
	LeftVU.setSpeed(50);
	RightVU.setSpeed(50);
	OneFrame = 255/(MainVis.getLength());
	OneFrame2 = 255/(RightVU.getLength());

}
	
System.onScriptUnloading() {
  VisTimer.stop();
  delete VisTimer;
}


VisTimer.onTimer() {
	LevelL = ((System.getLeftVuMeter() + System.getRightVuMeter())/2);
	LevelR = ((System.getLeftVuMeter() + System.getRightVuMeter())/2);
	Level = ((LevelL + LevelR)/2);
	UpdateVis(Level/OneFrame,LevelL/OneFrame2,LevelR/OneFrame2);
}
UpdateVis(int vFrame, int vFrameL, int vFrameR){
	//Vis
	MainVis.setStartFrame(LastFrame);
     	MainVis.setEndFrame(vFrame);
     	MainVis.play();
     	LastFrame = vFrame;
	//VuL
	LeftVU.setStartFrame(LastFrameL);
     	LeftVU.setEndFrame(vFrameL);
     	LeftVU.play();
     	LastFrameL = vFrameL;
	//VuR
	RightVU.setStartFrame(LastFrameR);
     	RightVU.setEndFrame(vFrameR);
     	RightVU.play();
     	LastFrameR = vFrameR;
}